using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Driver;
using MudBlazor;

namespace Insight.Web.Pages.Management.Hosts;

public partial class HostEditDialog
{
    [CascadingParameter(Name = "Host")] public ViewModel? Host { get; set; }
    [Parameter] public EventCallback OnChanges { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private ILogger<HostEditDialog> Logger { get; init; } = default!;

    private async Task SubmitAsync()
    {
        if (Host is null) return;

        try
        {
            await Database.Host().UpdateOneAsync(Builders<HostEntity>
                .Filter
                .Eq(p => p.Id, Host.Id.ToString()), Builders<HostEntity>
                .Update
                .Set(p => p.Update, DateTime.Now)
                .Set(p => p.Name, Host.Name)
                .Set(p => p.Description, Host.Description),
                cancellationToken: default);

            Notification.Success(Snackbar);

            if (OnChanges.HasDelegate)
            {
                await InvokeAsync(async () =>
                {
                    await OnChanges.InvokeAsync(this);
                });
            }
        }
        catch (Exception ex)
        {
            Notification.Error(Snackbar);
            Logger.LogError(ex.ToString());
        }
        finally
        {
            _visible = false;
        }
    }
}